<?php
/**
 * Clase Base FN para BaseCrSucursalValidadorFN
 *
 * @package    
 * @subpackage BaseCrSucursalValidadorFN
 * @author     Willy
 * @version    SVN:: BaseCrSucursalValidadorFN.class.php,v 1.1 2022-12-31 10:02:33 william.taype Exp $
 */
class BaseCrSucursalValidadorFN extends CrSucursalValidadorBN
{
  private static $fieldNames = array (
    'IdSucursal'=>'IdSucursal', 'IdColaborador'=>'IdColaborador', 'IdRol'=>'IdRol', 'Estado'=>'Estado', 'FechaCreacion'=>'FechaCreacion', 'UsuarioCreacion'=>'UsuarioCreacion'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT IdSucursal, IdColaborador, IdRol, Estado, FechaCreacion, UsuarioCreacion FROM cr_sucursal_validador WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
      
      mysql_db_query(Conexion::getNameDb(), "SET NAMES 'utf8'", $con);
      $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT IdSucursal, IdColaborador, IdRol, Estado, FechaCreacion, UsuarioCreacion FROM cr_sucursal_validador WHERE 1 ".$where;
         mysql_db_query(Conexion::getNameDb(), "SET NAMES 'utf8'", $con);
      $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdSucursal()){ $where .= " AND idsucursal = '".$this->getIdSucursal()."'"; }
      if($this->getIdColaborador()){ $where .= " AND idcolaborador = '".$this->getIdColaborador()."'"; }
      if($this->getIdRol()){ $where .= " AND idrol = '".$this->getIdRol()."'"; }
      if($this->getEstado()){ $where .= " AND estado = '".$this->getEstado()."'"; }
      if($this->getFechaCreacion()){ $where .= " AND fechacreacion = '".$this->getFechaCreacion()."'"; }
      if($this->getUsuarioCreacion()){ $where .= " AND usuariocreacion = '".$this->getUsuarioCreacion()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* B�squeda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IdSucursal, IdColaborador, IdRol, Estado, FechaCreacion, UsuarioCreacion FROM cr_sucursal_validador WHERE 1 AND IdSucursal='".$this->getIdSucursal()."' AND IdColaborador='".$this->getIdColaborador()."'; ";
         mysql_db_query(Conexion::getNameDb(), "SET NAMES 'utf8'", $con);
      $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseCrSucursalValidadorFN = new BaseCrSucursalValidadorFN();
    $o_BaseCrSucursalValidadorFN->setIdSucursal($o_propel->IdSucursal);
    $o_BaseCrSucursalValidadorFN->setIdColaborador($o_propel->IdColaborador);
    $o_BaseCrSucursalValidadorFN->setIdRol($o_propel->IdRol);
    $o_BaseCrSucursalValidadorFN->setEstado($o_propel->Estado);
    $o_BaseCrSucursalValidadorFN->setFechaCreacion($o_propel->FechaCreacion);
    $o_BaseCrSucursalValidadorFN->setUsuarioCreacion($o_propel->UsuarioCreacion);
    return $o_BaseCrSucursalValidadorFN;
  }
}